
package cn.orionsec.ops.handler.exporter;

import cn.orionsec.kit.lang.utils.convert.Converts;
import cn.orionsec.kit.spring.SpringHolder;
import cn.orionsec.ops.constant.ExportType;
import cn.orionsec.ops.dao.ApplicationInfoDAO;
import cn.orionsec.ops.dao.ApplicationRepositoryDAO;
import cn.orionsec.ops.entity.domain.ApplicationInfoDO;
import cn.orionsec.ops.entity.domain.ApplicationRepositoryDO;
import cn.orionsec.ops.entity.exporter.ApplicationExportDTO;
import cn.orionsec.ops.entity.request.data.DataExportRequest;

import javax.servlet.http.HttpServletResponse;
import java.util.List;
import java.util.Objects;
import java.util.stream.Collectors;

public class ApplicationDataExporter extends AbstractDataExporter<ApplicationExportDTO> {

    private static final ApplicationInfoDAO applicationInfoDAO = SpringHolder.getBean(ApplicationInfoDAO.class);

    private static final ApplicationRepositoryDAO applicationRepositoryDAO = SpringHolder.getBean(ApplicationRepositoryDAO.class);

    public ApplicationDataExporter(DataExportRequest request, HttpServletResponse response) {
        super(ExportType.APPLICATION, request, response);
    }

    @Override
    protected List<ApplicationExportDTO> queryData() {
        // 查询数据
        List<ApplicationInfoDO> appList = applicationInfoDAO.selectList(null);
        List<ApplicationExportDTO> exportList = Converts.toList(appList, ApplicationExportDTO.class);
        // 仓库名称
        List<Long> repoIdList = appList.stream()
                .map(ApplicationInfoDO::getRepoId)
                .filter(Objects::nonNull)
                .collect(Collectors.toList());
        if (!repoIdList.isEmpty()) {
            List<ApplicationRepositoryDO> repoNameList = applicationRepositoryDAO.selectNameByIdList(repoIdList);
            // 设置仓库名称
            for (ApplicationExportDTO export : exportList) {
                Long repoId = export.getRepoId();
                if (repoId == null) {
                    continue;
                }
                repoNameList.stream()
                        .filter(s -> s.getId().equals(repoId))
                        .findFirst()
                        .ifPresent(s -> export.setRepoName(s.getRepoName()));
            }
        }
        return exportList;
    }

}
